from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.ext.webapp import template

from google.appengine.api import users

import datetime
import logging

import models

# Loads the HTML of the webapp only
class MainPage(webapp.RequestHandler):
     def get(self):       
          User_Prefs = models.getUserPrefs()
          logging.info(User_Prefs.mode)
          logging.info(User_Prefs.status)
          
          if User_Prefs.run_time == None:
               run_time = ''
          else:
               run_time = User_Prefs.run_time
               
          if User_Prefs.idle_time == None:
               idle_time = ''
          else:
               idle_time = User_Prefs.idle_time
          
          modes = models.getModes()          
	
          html = template.render('templates/index.htm', {
               'title': 'Pump Controller',
               'modes': modes,
               'current_mode': User_Prefs.mode,
               'pump_status': User_Prefs.status,
               'runTime': run_time,
               'idleTime': idle_time
          })

          self.response.out.write(html)

class UpdateMode(webapp.RequestHandler):
     def get(self):
          
          logging.info(self.request.get('Mode'))
          
          models.updateMode(self.request.get('Mode'))
          
          self.response.out.write('Ok')
          
class ManualUpdate(webapp.RequestHandler):
     def get(self):
          
          logging.info(self.request.get('State'))
          models.updateManualStatus(self.request.get('State'))
          
          self.response.out.write('Ok')
        
class UpdateToggleTime(webapp.RequestHandler):
     def get(self):
          
          prop = self.request.get('Property')
          val  = self.request.get('Value')
          
          logging.info(prop)
          logging.info(val)
          
          models.updateToggleTime(prop, val)
          
          self.response.out.write('Ok')
          
class GetPumpStatus(webapp.RequestHandler):
     def get(self):
          
          User_Prefs = models.getUserPrefs()
          
          self.response.out.write(User_Prefs.status)
        
app = webapp.WSGIApplication([
     ('/updateMode.*', UpdateMode),
     ('/manualUpdate.*', ManualUpdate),
     ('/updateToggleTime.*', UpdateToggleTime),
     ('/getPumpStatus', GetPumpStatus),
     ('/.*', MainPage)
     ], debug=True)

def main():
    run_wsgi_app(app)

if __name__=='__main__':
    main()
