var mode = '';
var state = '';

window.onload = function() {
     // Manual Mode
     $('#pump-image').click( function() {
          
          // Toggle the image to the new mode
          if ($('#pump-image').attr('src') == '/static/images/on.png') {               
               state = 'off';
          } else {               
               state = 'on';
          }
          
          // Update server
          makeRequest('/manualUpdate?State=' + state, true, manualUpdate);
     });
     
     // Update Toggle Times
     $('#runTime').blur( function() {
          makeRequest('updateToggleTime?Property=RunTime&Value=' + $('#runTime').val(), true, doNothing);
     });
          
     $('#idleTime').blur( function() {
          makeRequest('updateToggleTime?Property=IdleTime&Value=' + $('#idleTime').val(), true, doNothing);
     });    
     
     // Set interval to update pump status
     setInterval(GetPumpStatus, 30000);
}

function setMode(newMode) {
     mode = newMode.value;
     
     makeRequest('/updateMode?Mode=' + mode, true, updateMode);
}

function updateMode() {
     if (mode == 'Toggle') {
          $('#toggleDetails').css('visibility', 'visible');
     } else {
          $('#toggleDetails').css('visibility', 'hidden');
     }
}

function doNothing() {
     
}

function manualUpdate() {
     // Update image
     $('#pump-image').attr('src', '/static/images/' + state + '.png');
     
     // Mode selector to 'Manual'
     $('#mode').val('Manual');
     
     // Toggle details hidden
     $('#toggleDetails').css('visibility', 'hidden');
}

function GetPumpStatus() {
     makeRequest('/getPumpStatus?Random=' + (new Date()).getTime(), true, UpdatePumpStatus);
}

function UpdatePumpStatus() {
     console.log(request.responseText);
     $('#pump-image').attr('src', '/static/images/' + request.responseText + '.png');
}


function createRequest() {
     try {
       var request = new XMLHttpRequest();
     } catch (tryMS) {
       try {
            request = new ActiveXObject('Msxm12.XMLHTTP');
       } catch (otherMS) {
            try {
              request = new ActiveXObject('Microsoft.XMLHTTP');
            } catch (failed) {
              request = null;
            }
       }
     }  
     
     return(request);
}

function makeRequest(url, async, nextFunction) {
     request = createRequest();
     
     if (request != null) {
          request.open('GET', url, async);
          request.onreadystatechange = function() {
               if (request.readyState == 4 && request.status == 200) {
                    nextFunction();
               }
          }
          request.send(null);
     } else {
       alert('Unable to make request');
     }
}



     